

# Actions
<a name="API_Operations"></a>

The following actions are supported:
+  [AssociateServiceRoleToAccount](API_AssociateServiceRoleToAccount.md) 
+  [BatchAssociateClientDeviceWithCoreDevice](API_BatchAssociateClientDeviceWithCoreDevice.md) 
+  [BatchDisassociateClientDeviceFromCoreDevice](API_BatchDisassociateClientDeviceFromCoreDevice.md) 
+  [CancelDeployment](API_CancelDeployment.md) 
+  [CreateComponentVersion](API_CreateComponentVersion.md) 
+  [CreateDeployment](API_CreateDeployment.md) 
+  [DeleteComponent](API_DeleteComponent.md) 
+  [DeleteCoreDevice](API_DeleteCoreDevice.md) 
+  [DeleteDeployment](API_DeleteDeployment.md) 
+  [DescribeComponent](API_DescribeComponent.md) 
+  [DisassociateServiceRoleFromAccount](API_DisassociateServiceRoleFromAccount.md) 
+  [GetComponent](API_GetComponent.md) 
+  [GetComponentVersionArtifact](API_GetComponentVersionArtifact.md) 
+  [GetConnectivityInfo](API_GetConnectivityInfo.md) 
+  [GetCoreDevice](API_GetCoreDevice.md) 
+  [GetDeployment](API_GetDeployment.md) 
+  [GetServiceRoleForAccount](API_GetServiceRoleForAccount.md) 
+  [ListClientDevicesAssociatedWithCoreDevice](API_ListClientDevicesAssociatedWithCoreDevice.md) 
+  [ListComponents](API_ListComponents.md) 
+  [ListComponentVersions](API_ListComponentVersions.md) 
+  [ListCoreDevices](API_ListCoreDevices.md) 
+  [ListDeployments](API_ListDeployments.md) 
+  [ListEffectiveDeployments](API_ListEffectiveDeployments.md) 
+  [ListInstalledComponents](API_ListInstalledComponents.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [ResolveComponentCandidates](API_ResolveComponentCandidates.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateConnectivityInfo](API_UpdateConnectivityInfo.md) 

# AssociateServiceRoleToAccount
<a name="API_AssociateServiceRoleToAccount"></a>

Associates a Greengrass service role with AWS IoT Greengrass for your AWS account in this AWS Region. AWS IoT Greengrass uses this role to verify the identity of client devices and manage core device connectivity information. The role must include the [AWSGreengrassResourceAccessRolePolicy](https://console.aws.amazon.com/iam/home#/policies/arn:awsiam::aws:policy/service-role/AWSGreengrassResourceAccessRolePolicy) managed policy or a custom policy that defines equivalent permissions for the AWS IoT Greengrass features that you use. For more information, see [Greengrass service role](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-service-role.html) in the * AWS IoT Greengrass Version 2 Developer Guide*.

## Request Syntax
<a name="API_AssociateServiceRoleToAccount_RequestSyntax"></a>

```
PUT /greengrass/servicerole HTTP/1.1
Content-type: application/json

{
   "RoleArn": "string"
}
```

## URI Request Parameters
<a name="API_AssociateServiceRoleToAccount_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_AssociateServiceRoleToAccount_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [RoleArn](#API_AssociateServiceRoleToAccount_RequestSyntax) **   <a name="greengrassv2-AssociateServiceRoleToAccount-request-RoleArn"></a>
The Amazon Resource Name (ARN) of the service role to associate with AWS IoT Greengrass for your AWS account in this AWS Region.  
Type: String  
Required: Yes

## Response Syntax
<a name="API_AssociateServiceRoleToAccount_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "AssociatedAt": "string"
}
```

## Response Elements
<a name="API_AssociateServiceRoleToAccount_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [AssociatedAt](#API_AssociateServiceRoleToAccount_ResponseSyntax) **   <a name="greengrassv2-AssociateServiceRoleToAccount-response-AssociatedAt"></a>
The time when the service role was associated with AWS IoT Greengrass for your AWS account in this AWS Region.  
Type: String

## Errors
<a name="API_AssociateServiceRoleToAccount_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_AssociateServiceRoleToAccount_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/AssociateServiceRoleToAccount) 

# BatchAssociateClientDeviceWithCoreDevice
<a name="API_BatchAssociateClientDeviceWithCoreDevice"></a>

Associates a list of client devices with a core device. Use this API operation to specify which client devices can discover a core device through cloud discovery. With cloud discovery, client devices connect to AWS IoT Greengrass to retrieve associated core devices' connectivity information and certificates. For more information, see [Connect client devices to core devices](https://docs.aws.amazon.com/greengrass/v2/developerguide/connect-client-devices.html) in the * AWS IoT Greengrass V2 Developer Guide*.

**Note**  
Client devices are local IoT devices that connect to and communicate with an AWS IoT Greengrass core device over MQTT. You can connect client devices to a core device to sync MQTT messages and data to AWS IoT Core and interact with client devices in Greengrass components. For more information, see [Interact with local IoT devices](https://docs.aws.amazon.com/greengrass/v2/developerguide/interact-with-local-iot-devices.html) in the * AWS IoT Greengrass V2 Developer Guide*.

## Request Syntax
<a name="API_BatchAssociateClientDeviceWithCoreDevice_RequestSyntax"></a>

```
POST /greengrass/v2/coreDevices/coreDeviceThingName/associateClientDevices HTTP/1.1
Content-type: application/json

{
   "entries": [ 
      { 
         "thingName": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_BatchAssociateClientDeviceWithCoreDevice_RequestParameters"></a>

The request uses the following URI parameters.

 ** [coreDeviceThingName](#API_BatchAssociateClientDeviceWithCoreDevice_RequestSyntax) **   <a name="greengrassv2-BatchAssociateClientDeviceWithCoreDevice-request-uri-coreDeviceThingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_BatchAssociateClientDeviceWithCoreDevice_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [entries](#API_BatchAssociateClientDeviceWithCoreDevice_RequestSyntax) **   <a name="greengrassv2-BatchAssociateClientDeviceWithCoreDevice-request-entries"></a>
The list of client devices to associate.  
Type: Array of [AssociateClientDeviceWithCoreDeviceEntry](API_AssociateClientDeviceWithCoreDeviceEntry.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 100 items.  
Required: No

## Response Syntax
<a name="API_BatchAssociateClientDeviceWithCoreDevice_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "errorEntries": [ 
      { 
         "code": "string",
         "message": "string",
         "thingName": "string"
      }
   ]
}
```

## Response Elements
<a name="API_BatchAssociateClientDeviceWithCoreDevice_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [errorEntries](#API_BatchAssociateClientDeviceWithCoreDevice_ResponseSyntax) **   <a name="greengrassv2-BatchAssociateClientDeviceWithCoreDevice-response-errorEntries"></a>
The list of any errors for the entries in the request. Each error entry contains the name of the AWS IoT thing that failed to associate.  
Type: Array of [AssociateClientDeviceWithCoreDeviceErrorEntry](API_AssociateClientDeviceWithCoreDeviceErrorEntry.md) objects  
Array Members: Maximum number of 100 items.

## Errors
<a name="API_BatchAssociateClientDeviceWithCoreDevice_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_BatchAssociateClientDeviceWithCoreDevice_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/BatchAssociateClientDeviceWithCoreDevice) 

# BatchDisassociateClientDeviceFromCoreDevice
<a name="API_BatchDisassociateClientDeviceFromCoreDevice"></a>

Disassociates a list of client devices from a core device. After you disassociate a client device from a core device, the client device won't be able to use cloud discovery to retrieve the core device's connectivity information and certificates.

## Request Syntax
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_RequestSyntax"></a>

```
POST /greengrass/v2/coreDevices/coreDeviceThingName/disassociateClientDevices HTTP/1.1
Content-type: application/json

{
   "entries": [ 
      { 
         "thingName": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_RequestParameters"></a>

The request uses the following URI parameters.

 ** [coreDeviceThingName](#API_BatchDisassociateClientDeviceFromCoreDevice_RequestSyntax) **   <a name="greengrassv2-BatchDisassociateClientDeviceFromCoreDevice-request-uri-coreDeviceThingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [entries](#API_BatchDisassociateClientDeviceFromCoreDevice_RequestSyntax) **   <a name="greengrassv2-BatchDisassociateClientDeviceFromCoreDevice-request-entries"></a>
The list of client devices to disassociate.  
Type: Array of [DisassociateClientDeviceFromCoreDeviceEntry](API_DisassociateClientDeviceFromCoreDeviceEntry.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 100 items.  
Required: No

## Response Syntax
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "errorEntries": [ 
      { 
         "code": "string",
         "message": "string",
         "thingName": "string"
      }
   ]
}
```

## Response Elements
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [errorEntries](#API_BatchDisassociateClientDeviceFromCoreDevice_ResponseSyntax) **   <a name="greengrassv2-BatchDisassociateClientDeviceFromCoreDevice-response-errorEntries"></a>
The list of any errors for the entries in the request. Each error entry contains the name of the AWS IoT thing that failed to disassociate.  
Type: Array of [DisassociateClientDeviceFromCoreDeviceErrorEntry](API_DisassociateClientDeviceFromCoreDeviceErrorEntry.md) objects  
Array Members: Maximum number of 100 items.

## Errors
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_BatchDisassociateClientDeviceFromCoreDevice_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/BatchDisassociateClientDeviceFromCoreDevice) 

# CancelDeployment
<a name="API_CancelDeployment"></a>

Cancels a deployment. This operation cancels the deployment for devices that haven't yet received it. If a device already received the deployment, this operation doesn't change anything for that device.

## Request Syntax
<a name="API_CancelDeployment_RequestSyntax"></a>

```
POST /greengrass/v2/deployments/deploymentId/cancel HTTP/1.1
```

## URI Request Parameters
<a name="API_CancelDeployment_RequestParameters"></a>

The request uses the following URI parameters.

 ** [deploymentId](#API_CancelDeployment_RequestSyntax) **   <a name="greengrassv2-CancelDeployment-request-uri-deploymentId"></a>
The ID of the deployment.  
Length Constraints: Minimum length of 1.  
Required: Yes

## Request Body
<a name="API_CancelDeployment_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_CancelDeployment_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "message": "string"
}
```

## Response Elements
<a name="API_CancelDeployment_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [message](#API_CancelDeployment_ResponseSyntax) **   <a name="greengrassv2-CancelDeployment-response-message"></a>
A message that communicates if the cancel was successful.  
Type: String  
Length Constraints: Minimum length of 1.

## Errors
<a name="API_CancelDeployment_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_CancelDeployment_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/CancelDeployment) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/CancelDeployment) 

# CreateComponentVersion
<a name="API_CreateComponentVersion"></a>

Creates a component. Components are software that run on Greengrass core devices. After you develop and test a component on your core device, you can use this operation to upload your component to AWS IoT Greengrass. Then, you can deploy the component to other core devices.

You can use this operation to do the following:
+  **Create components from recipes** 

  Create a component from a recipe, which is a file that defines the component's metadata, parameters, dependencies, lifecycle, artifacts, and platform capability. For more information, see [AWS IoT Greengrass component recipe reference](https://docs.aws.amazon.com/greengrass/v2/developerguide/component-recipe-reference.html) in the * AWS IoT Greengrass V2 Developer Guide*.

  To create a component from a recipe, specify `inlineRecipe` when you call this operation.
+  **Create components from Lambda functions** 

  Create a component from an AWS Lambda function that runs on AWS IoT Greengrass. This creates a recipe and artifacts from the Lambda function's deployment package. You can use this operation to migrate Lambda functions from AWS IoT Greengrass V1 to AWS IoT Greengrass V2.

  This function accepts Lambda functions in all supported versions of Python, Node.js, and Java runtimes. AWS IoT Greengrass doesn't apply any additional restrictions on deprecated Lambda runtime versions.

  To create a component from a Lambda function, specify `lambdaFunction` when you call this operation.
**Note**  
 AWS IoT Greengrass currently supports Lambda functions on only Linux core devices.

## Request Syntax
<a name="API_CreateComponentVersion_RequestSyntax"></a>

```
POST /greengrass/v2/createComponentVersion HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "inlineRecipe": blob,
   "lambdaFunction": { 
      "componentDependencies": { 
         "string" : { 
            "dependencyType": "string",
            "versionRequirement": "string"
         }
      },
      "componentLambdaParameters": { 
         "environmentVariables": { 
            "string" : "string" 
         },
         "eventSources": [ 
            { 
               "topic": "string",
               "type": "string"
            }
         ],
         "execArgs": [ "string" ],
         "inputPayloadEncodingType": "string",
         "linuxProcessParams": { 
            "containerParams": { 
               "devices": [ 
                  { 
                     "addGroupOwner": boolean,
                     "path": "string",
                     "permission": "string"
                  }
               ],
               "memorySizeInKB": number,
               "mountROSysfs": boolean,
               "volumes": [ 
                  { 
                     "addGroupOwner": boolean,
                     "destinationPath": "string",
                     "permission": "string",
                     "sourcePath": "string"
                  }
               ]
            },
            "isolationMode": "string"
         },
         "maxIdleTimeInSeconds": number,
         "maxInstancesCount": number,
         "maxQueueSize": number,
         "pinned": boolean,
         "statusTimeoutInSeconds": number,
         "timeoutInSeconds": number
      },
      "componentName": "string",
      "componentPlatforms": [ 
         { 
            "attributes": { 
               "string" : "string" 
            },
            "name": "string"
         }
      ],
      "componentVersion": "string",
      "lambdaArn": "string"
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateComponentVersion_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateComponentVersion_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateComponentVersion_RequestSyntax) **   <a name="greengrassv2-CreateComponentVersion-request-clientToken"></a>
A unique, case-sensitive identifier that you can provide to ensure that the request is idempotent. Idempotency means that the request is successfully processed only once, even if you send the request multiple times. When a request succeeds, and you specify the same client token for subsequent successful requests, the AWS IoT Greengrass V2 service returns the successful response that it caches from the previous request. AWS IoT Greengrass V2 caches successful responses for idempotent requests for up to 8 hours.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^[a-zA-Z0-9-]+$`   
Required: No

 ** [inlineRecipe](#API_CreateComponentVersion_RequestSyntax) **   <a name="greengrassv2-CreateComponentVersion-request-inlineRecipe"></a>
The recipe to use to create the component. The recipe defines the component's metadata, parameters, dependencies, lifecycle, artifacts, and platform compatibility.  
You must specify either `inlineRecipe` or `lambdaFunction`.  
Type: Base64-encoded binary data object  
Required: No

 ** [lambdaFunction](#API_CreateComponentVersion_RequestSyntax) **   <a name="greengrassv2-CreateComponentVersion-request-lambdaFunction"></a>
The parameters to create a component from a Lambda function.  
You must specify either `inlineRecipe` or `lambdaFunction`.  
Type: [LambdaFunctionRecipeSource](API_LambdaFunctionRecipeSource.md) object  
Required: No

 ** [tags](#API_CreateComponentVersion_RequestSyntax) **   <a name="greengrassv2-CreateComponentVersion-request-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.aws.amazon.com/greengrass/v2/developerguide/tag-resources.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.  
Required: No

## Response Syntax
<a name="API_CreateComponentVersion_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "componentName": "string",
   "componentVersion": "string",
   "creationTimestamp": number,
   "status": { 
      "componentState": "string",
      "errors": { 
         "string" : "string" 
      },
      "message": "string",
      "vendorGuidance": "string",
      "vendorGuidanceMessage": "string"
   }
}
```

## Response Elements
<a name="API_CreateComponentVersion_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_CreateComponentVersion_ResponseSyntax) **   <a name="greengrassv2-CreateComponentVersion-response-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version.  
Type: String  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+` 

 ** [componentName](#API_CreateComponentVersion_ResponseSyntax) **   <a name="greengrassv2-CreateComponentVersion-response-componentName"></a>
The name of the component.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [componentVersion](#API_CreateComponentVersion_ResponseSyntax) **   <a name="greengrassv2-CreateComponentVersion-response-componentVersion"></a>
The version of the component.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.

 ** [creationTimestamp](#API_CreateComponentVersion_ResponseSyntax) **   <a name="greengrassv2-CreateComponentVersion-response-creationTimestamp"></a>
The time at which the component was created, expressed in ISO 8601 format.  
Type: Timestamp

 ** [status](#API_CreateComponentVersion_ResponseSyntax) **   <a name="greengrassv2-CreateComponentVersion-response-status"></a>
The status of the component version in AWS IoT Greengrass V2. This status is different from the status of the component on a core device.  
Type: [CloudComponentStatus](API_CloudComponentStatus.md) object

## Errors
<a name="API_CreateComponentVersion_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** RequestAlreadyInProgressException **   
The request is already in progress. This exception occurs when you use a client token for multiple requests while AWS IoT Greengrass is still processing an earlier request that uses the same client token.  
HTTP Status Code: 400

 ** ServiceQuotaExceededException **   
Your request exceeds a service quota. For example, you might have the maximum number of components that you can create.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** resourceId **   
The ID of the resource that exceeds the service quota.  
 ** resourceType **   
The type of the resource that exceeds the service quota.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 402

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_CreateComponentVersion_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/CreateComponentVersion) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/CreateComponentVersion) 

# CreateDeployment
<a name="API_CreateDeployment"></a>

Creates a continuous deployment for a target, which is a Greengrass core device or group of core devices. When you add a new core device to a group of core devices that has a deployment, AWS IoT Greengrass deploys that group's deployment to the new device.

You can define one deployment for each target. When you create a new deployment for a target that has an existing deployment, you replace the previous deployment. AWS IoT Greengrass applies the new deployment to the target devices.

Every deployment has a revision number that indicates how many deployment revisions you define for a target. Use this operation to create a new revision of an existing deployment.

For more information, see the [Create deployments](https://docs.aws.amazon.com/greengrass/v2/developerguide/create-deployments.html) in the * AWS IoT Greengrass V2 Developer Guide*.

## Request Syntax
<a name="API_CreateDeployment_RequestSyntax"></a>

```
POST /greengrass/v2/deployments HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "components": { 
      "string" : { 
         "componentVersion": "string",
         "configurationUpdate": { 
            "merge": "string",
            "reset": [ "string" ]
         },
         "runWith": { 
            "posixUser": "string",
            "systemResourceLimits": { 
               "cpus": number,
               "memory": number
            },
            "windowsUser": "string"
         }
      }
   },
   "deploymentName": "string",
   "deploymentPolicies": { 
      "componentUpdatePolicy": { 
         "action": "string",
         "timeoutInSeconds": number
      },
      "configurationValidationPolicy": { 
         "timeoutInSeconds": number
      },
      "failureHandlingPolicy": "string"
   },
   "iotJobConfiguration": { 
      "abortConfig": { 
         "criteriaList": [ 
            { 
               "action": "string",
               "failureType": "string",
               "minNumberOfExecutedThings": number,
               "thresholdPercentage": number
            }
         ]
      },
      "jobExecutionsRolloutConfig": { 
         "exponentialRate": { 
            "baseRatePerMinute": number,
            "incrementFactor": number,
            "rateIncreaseCriteria": { 
               "numberOfNotifiedThings": number,
               "numberOfSucceededThings": number
            }
         },
         "maximumPerMinute": number
      },
      "timeoutConfig": { 
         "inProgressTimeoutInMinutes": number
      }
   },
   "parentTargetArn": "string",
   "tags": { 
      "string" : "string" 
   },
   "targetArn": "string"
}
```

## URI Request Parameters
<a name="API_CreateDeployment_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateDeployment_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-clientToken"></a>
A unique, case-sensitive identifier that you can provide to ensure that the request is idempotent. Idempotency means that the request is successfully processed only once, even if you send the request multiple times. When a request succeeds, and you specify the same client token for subsequent successful requests, the AWS IoT Greengrass V2 service returns the successful response that it caches from the previous request. AWS IoT Greengrass V2 caches successful responses for idempotent requests for up to 8 hours.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^[a-zA-Z0-9-]+$`   
Required: No

 ** [components](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-components"></a>
The components to deploy. This is a dictionary, where each key is the name of a component, and each key's value is the version and configuration to deploy for that component.  
Type: String to [ComponentDeploymentSpecification](API_ComponentDeploymentSpecification.md) object map  
Key Length Constraints: Minimum length of 1.  
Required: No

 ** [deploymentName](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-deploymentName"></a>
The name of the deployment.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: No

 ** [deploymentPolicies](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-deploymentPolicies"></a>
The deployment policies for the deployment. These policies define how the deployment updates components and handles failure.  
Type: [DeploymentPolicies](API_DeploymentPolicies.md) object  
Required: No

 ** [iotJobConfiguration](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-iotJobConfiguration"></a>
The job configuration for the deployment configuration. The job configuration specifies the rollout, timeout, and stop configurations for the deployment configuration.  
Type: [DeploymentIoTJobConfiguration](API_DeploymentIoTJobConfiguration.md) object  
Required: No

 ** [parentTargetArn](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-parentTargetArn"></a>
The parent deployment's target [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) within a subdeployment.  
Type: String  
Pattern: `arn:[^:]*:iot:[^:]*:[0-9]+:thinggroup/.+`   
Required: No

 ** [tags](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.aws.amazon.com/greengrass/v2/developerguide/tag-resources.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.  
Required: No

 ** [targetArn](#API_CreateDeployment_RequestSyntax) **   <a name="greengrassv2-CreateDeployment-request-targetArn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the target AWS IoT thing or thing group. When creating a subdeployment, the targetARN can only be a thing group.  
Type: String  
Pattern: `arn:[^:]*:iot:[^:]*:[0-9]+:(thing|thinggroup)/.+`   
Required: Yes

## Response Syntax
<a name="API_CreateDeployment_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "deploymentId": "string",
   "iotJobArn": "string",
   "iotJobId": "string"
}
```

## Response Elements
<a name="API_CreateDeployment_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [deploymentId](#API_CreateDeployment_ResponseSyntax) **   <a name="greengrassv2-CreateDeployment-response-deploymentId"></a>
The ID of the deployment.  
Type: String  
Length Constraints: Minimum length of 1.

 ** [iotJobArn](#API_CreateDeployment_ResponseSyntax) **   <a name="greengrassv2-CreateDeployment-response-iotJobArn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the AWS IoT job that applies the deployment to target devices.  
Type: String  
Pattern: `arn:[^:]*:iot:[^:]+:[0-9]+:job/.+` 

 ** [iotJobId](#API_CreateDeployment_ResponseSyntax) **   <a name="greengrassv2-CreateDeployment-response-iotJobId"></a>
The ID of the AWS IoT job that applies the deployment to target devices.  
Type: String  
Length Constraints: Minimum length of 1.

## Errors
<a name="API_CreateDeployment_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** RequestAlreadyInProgressException **   
The request is already in progress. This exception occurs when you use a client token for multiple requests while AWS IoT Greengrass is still processing an earlier request that uses the same client token.  
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_CreateDeployment_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/CreateDeployment) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/CreateDeployment) 

# DeleteComponent
<a name="API_DeleteComponent"></a>

Deletes a version of a component from AWS IoT Greengrass.

**Note**  
This operation deletes the component's recipe and artifacts. As a result, deployments that refer to this component version will fail. If you have deployments that use this component version, you can remove the component from the deployment or update the deployment to use a valid version.

## Request Syntax
<a name="API_DeleteComponent_RequestSyntax"></a>

```
DELETE /greengrass/v2/components/arn HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteComponent_RequestParameters"></a>

The request uses the following URI parameters.

 ** [arn](#API_DeleteComponent_RequestSyntax) **   <a name="greengrassv2-DeleteComponent-request-uri-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version.  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+`   
Required: Yes

## Request Body
<a name="API_DeleteComponent_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteComponent_ResponseSyntax"></a>

```
HTTP/1.1 204
```

## Response Elements
<a name="API_DeleteComponent_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 204 response with an empty HTTP body.

## Errors
<a name="API_DeleteComponent_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_DeleteComponent_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/DeleteComponent) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/DeleteComponent) 

# DeleteCoreDevice
<a name="API_DeleteCoreDevice"></a>

Deletes a Greengrass core device, which is an AWS IoT thing. This operation removes the core device from the list of core devices. This operation doesn't delete the AWS IoT thing. For more information about how to delete the AWS IoT thing, see [DeleteThing](https://docs.aws.amazon.com/iot/latest/apireference/API_DeleteThing.html) in the * AWS IoT API Reference*.

## Request Syntax
<a name="API_DeleteCoreDevice_RequestSyntax"></a>

```
DELETE /greengrass/v2/coreDevices/coreDeviceThingName HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteCoreDevice_RequestParameters"></a>

The request uses the following URI parameters.

 ** [coreDeviceThingName](#API_DeleteCoreDevice_RequestSyntax) **   <a name="greengrassv2-DeleteCoreDevice-request-uri-coreDeviceThingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_DeleteCoreDevice_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteCoreDevice_ResponseSyntax"></a>

```
HTTP/1.1 204
```

## Response Elements
<a name="API_DeleteCoreDevice_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 204 response with an empty HTTP body.

## Errors
<a name="API_DeleteCoreDevice_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_DeleteCoreDevice_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/DeleteCoreDevice) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/DeleteCoreDevice) 

# DeleteDeployment
<a name="API_DeleteDeployment"></a>

Deletes a deployment. To delete an active deployment, you must first cancel it. For more information, see [CancelDeployment](https://docs.aws.amazon.com/iot/latest/apireference/API_CancelDeployment.html).

Deleting a deployment doesn't affect core devices that run that deployment, because core devices store the deployment's configuration on the device. Additionally, core devices can roll back to a previous deployment that has been deleted.

Deleting the AWS IoT job associated with a deployment may take time. While the job is being deleted, the status of the job will be shown as "DELETION\$1IN\$1PROGRESS". Only 10 jobs may have status "DELETION\$1IN\$1PROGRESS" at the same time. If Greengrass is unable to delete a job because of this limit, the DeleteDeployment operation will return `ThrottlingException`.

## Request Syntax
<a name="API_DeleteDeployment_RequestSyntax"></a>

```
DELETE /greengrass/v2/deployments/deploymentId HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteDeployment_RequestParameters"></a>

The request uses the following URI parameters.

 ** [deploymentId](#API_DeleteDeployment_RequestSyntax) **   <a name="greengrassv2-DeleteDeployment-request-uri-deploymentId"></a>
The ID of the deployment.  
Length Constraints: Minimum length of 1.  
Required: Yes

## Request Body
<a name="API_DeleteDeployment_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteDeployment_ResponseSyntax"></a>

```
HTTP/1.1 204
```

## Response Elements
<a name="API_DeleteDeployment_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 204 response with an empty HTTP body.

## Errors
<a name="API_DeleteDeployment_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** ConflictException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceId **   
The ID of the resource that conflicts with the request.  
 ** resourceType **   
The type of the resource that conflicts with the request.
HTTP Status Code: 409

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_DeleteDeployment_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/DeleteDeployment) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/DeleteDeployment) 

# DescribeComponent
<a name="API_DescribeComponent"></a>

Retrieves metadata for a version of a component.

## Request Syntax
<a name="API_DescribeComponent_RequestSyntax"></a>

```
GET /greengrass/v2/components/arn/metadata HTTP/1.1
```

## URI Request Parameters
<a name="API_DescribeComponent_RequestParameters"></a>

The request uses the following URI parameters.

 ** [arn](#API_DescribeComponent_RequestSyntax) **   <a name="greengrassv2-DescribeComponent-request-uri-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version.  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+`   
Required: Yes

## Request Body
<a name="API_DescribeComponent_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DescribeComponent_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "componentName": "string",
   "componentVersion": "string",
   "creationTimestamp": number,
   "description": "string",
   "platforms": [ 
      { 
         "attributes": { 
            "string" : "string" 
         },
         "name": "string"
      }
   ],
   "publisher": "string",
   "status": { 
      "componentState": "string",
      "errors": { 
         "string" : "string" 
      },
      "message": "string",
      "vendorGuidance": "string",
      "vendorGuidanceMessage": "string"
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_DescribeComponent_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version.  
Type: String  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+` 

 ** [componentName](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-componentName"></a>
The name of the component.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [componentVersion](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-componentVersion"></a>
The version of the component.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.

 ** [creationTimestamp](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-creationTimestamp"></a>
The time at which the component was created, expressed in ISO 8601 format.  
Type: Timestamp

 ** [description](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-description"></a>
The description of the component version.  
Type: String

 ** [platforms](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-platforms"></a>
The platforms that the component version supports.  
Type: Array of [ComponentPlatform](API_ComponentPlatform.md) objects

 ** [publisher](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-publisher"></a>
The publisher of the component version.  
Type: String

 ** [status](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-status"></a>
The status of the component version in AWS IoT Greengrass V2. This status is different from the status of the component on a core device.  
Type: [CloudComponentStatus](API_CloudComponentStatus.md) object

 ** [tags](#API_DescribeComponent_ResponseSyntax) **   <a name="greengrassv2-DescribeComponent-response-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.aws.amazon.com/greengrass/v2/developerguide/tag-resources.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.

## Errors
<a name="API_DescribeComponent_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_DescribeComponent_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/DescribeComponent) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/DescribeComponent) 

# DisassociateServiceRoleFromAccount
<a name="API_DisassociateServiceRoleFromAccount"></a>

Disassociates the Greengrass service role from AWS IoT Greengrass for your AWS account in this AWS Region. Without a service role, AWS IoT Greengrass can't verify the identity of client devices or manage core device connectivity information. For more information, see [Greengrass service role](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-service-role.html) in the * AWS IoT Greengrass Version 2 Developer Guide*.

## Request Syntax
<a name="API_DisassociateServiceRoleFromAccount_RequestSyntax"></a>

```
DELETE /greengrass/servicerole HTTP/1.1
```

## URI Request Parameters
<a name="API_DisassociateServiceRoleFromAccount_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DisassociateServiceRoleFromAccount_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DisassociateServiceRoleFromAccount_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "DisassociatedAt": "string"
}
```

## Response Elements
<a name="API_DisassociateServiceRoleFromAccount_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [DisassociatedAt](#API_DisassociateServiceRoleFromAccount_ResponseSyntax) **   <a name="greengrassv2-DisassociateServiceRoleFromAccount-response-DisassociatedAt"></a>
The time when the service role was disassociated from AWS IoT Greengrass for your AWS account in this AWS Region.  
Type: String

## Errors
<a name="API_DisassociateServiceRoleFromAccount_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

## See Also
<a name="API_DisassociateServiceRoleFromAccount_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/DisassociateServiceRoleFromAccount) 

# GetComponent
<a name="API_GetComponent"></a>

Gets the recipe for a version of a component.

## Request Syntax
<a name="API_GetComponent_RequestSyntax"></a>

```
GET /greengrass/v2/components/arn?recipeOutputFormat=recipeOutputFormat HTTP/1.1
```

## URI Request Parameters
<a name="API_GetComponent_RequestParameters"></a>

The request uses the following URI parameters.

 ** [arn](#API_GetComponent_RequestSyntax) **   <a name="greengrassv2-GetComponent-request-uri-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version.  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+`   
Required: Yes

 ** [recipeOutputFormat](#API_GetComponent_RequestSyntax) **   <a name="greengrassv2-GetComponent-request-uri-recipeOutputFormat"></a>
The format of the recipe.  
Valid Values: `JSON | YAML` 

## Request Body
<a name="API_GetComponent_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetComponent_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "recipe": blob,
   "recipeOutputFormat": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_GetComponent_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [recipe](#API_GetComponent_ResponseSyntax) **   <a name="greengrassv2-GetComponent-response-recipe"></a>
The recipe of the component version.  
Type: Base64-encoded binary data object

 ** [recipeOutputFormat](#API_GetComponent_ResponseSyntax) **   <a name="greengrassv2-GetComponent-response-recipeOutputFormat"></a>
The format of the recipe.  
Type: String  
Valid Values: `JSON | YAML` 

 ** [tags](#API_GetComponent_ResponseSyntax) **   <a name="greengrassv2-GetComponent-response-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.aws.amazon.com/greengrass/v2/developerguide/tag-resources.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.

## Errors
<a name="API_GetComponent_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetComponent_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/GetComponent) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/GetComponent) 

# GetComponentVersionArtifact
<a name="API_GetComponentVersionArtifact"></a>

Gets the pre-signed URL to download a public or a Lambda component artifact. Core devices call this operation to identify the URL that they can use to download an artifact to install.

## Request Syntax
<a name="API_GetComponentVersionArtifact_RequestSyntax"></a>

```
GET /greengrass/v2/components/arn/artifacts/artifactName+?s3EndpointType=s3EndpointType HTTP/1.1
x-amz-iot-endpoint-type: iotEndpointType
```

## URI Request Parameters
<a name="API_GetComponentVersionArtifact_RequestParameters"></a>

The request uses the following URI parameters.

 ** [arn](#API_GetComponentVersionArtifact_RequestSyntax) **   <a name="greengrassv2-GetComponentVersionArtifact-request-uri-arn"></a>
The [ARN](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) of the component version. Specify the ARN of a public or a Lambda component version.  
Pattern: `arn:[^:]*:greengrass:[^:]*:(aws|[0-9]+):components:[^:]+:versions:[^:]+`   
Required: Yes

 ** [artifactName](#API_GetComponentVersionArtifact_RequestSyntax) **   <a name="greengrassv2-GetComponentVersionArtifact-request-uri-artifactName"></a>
The name of the artifact.  
You can use the [GetComponent](https://docs.aws.amazon.com/greengrass/v2/APIReference/API_GetComponent.html) operation to download the component recipe, which includes the URI of the artifact. The artifact name is the section of the URI after the scheme. For example, in the artifact URI `greengrass:SomeArtifact.zip`, the artifact name is `SomeArtifact.zip`.  
Length Constraints: Minimum length of 1.  
Required: Yes

 ** [iotEndpointType](#API_GetComponentVersionArtifact_RequestSyntax) **   <a name="greengrassv2-GetComponentVersionArtifact-request-iotEndpointType"></a>
Determines if the Amazon S3 URL returned is a FIPS pre-signed URL endpoint. Specify `fips` if you want the returned Amazon S3 pre-signed URL to point to an Amazon S3 FIPS endpoint. If you don't specify a value, the default is `standard`.  
Valid Values: `fips | standard` 

 ** [s3EndpointType](#API_GetComponentVersionArtifact_RequestSyntax) **   <a name="greengrassv2-GetComponentVersionArtifact-request-uri-s3EndpointType"></a>
Specifies the endpoint to use when getting Amazon S3 pre-signed URLs.  
All AWS Regions except US East (N. Virginia) use `REGIONAL` in all cases. In the US East (N. Virginia) Region the default is `GLOBAL`, but you can change it to `REGIONAL` with this parameter.  
Valid Values: `REGIONAL | GLOBAL` 

## Request Body
<a name="API_GetComponentVersionArtifact_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetComponentVersionArtifact_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "preSignedUrl": "string"
}
```

## Response Elements
<a name="API_GetComponentVersionArtifact_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [preSignedUrl](#API_GetComponentVersionArtifact_ResponseSyntax) **   <a name="greengrassv2-GetComponentVersionArtifact-response-preSignedUrl"></a>
The URL of the artifact.  
Type: String  
Length Constraints: Minimum length of 1.

## Errors
<a name="API_GetComponentVersionArtifact_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetComponentVersionArtifact_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/GetComponentVersionArtifact) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/GetComponentVersionArtifact) 

# GetConnectivityInfo
<a name="API_GetConnectivityInfo"></a>

Retrieves connectivity information for a Greengrass core device.

Connectivity information includes endpoints and ports where client devices can connect to an MQTT broker on the core device. When a client device calls the [AWS IoT Greengrass discovery API](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-discover-api.html), AWS IoT Greengrass returns connectivity information for all of the core devices where the client device can connect. For more information, see [Connect client devices to core devices](https://docs.aws.amazon.com/greengrass/v2/developerguide/connect-client-devices.html) in the * AWS IoT Greengrass Version 2 Developer Guide*.

## Request Syntax
<a name="API_GetConnectivityInfo_RequestSyntax"></a>

```
GET /greengrass/things/thingName/connectivityInfo HTTP/1.1
```

## URI Request Parameters
<a name="API_GetConnectivityInfo_RequestParameters"></a>

The request uses the following URI parameters.

 ** [thingName](#API_GetConnectivityInfo_RequestSyntax) **   <a name="greengrassv2-GetConnectivityInfo-request-uri-thingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_GetConnectivityInfo_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetConnectivityInfo_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "ConnectivityInfo": [ 
      { 
         "HostAddress": "string",
         "Id": "string",
         "Metadata": "string",
         "PortNumber": number
      }
   ],
   "Message": "string"
}
```

## Response Elements
<a name="API_GetConnectivityInfo_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [ConnectivityInfo](#API_GetConnectivityInfo_ResponseSyntax) **   <a name="greengrassv2-GetConnectivityInfo-response-ConnectivityInfo"></a>
The connectivity information for the core device.  
Type: Array of [ConnectivityInfo](API_ConnectivityInfo.md) objects

 ** [Message](#API_GetConnectivityInfo_ResponseSyntax) **   <a name="greengrassv2-GetConnectivityInfo-response-Message"></a>
A message about the connectivity information request.  
Type: String

## Errors
<a name="API_GetConnectivityInfo_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetConnectivityInfo_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/GetConnectivityInfo) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/greengrassv2-2020-11-30/GetConnectivityInfo) 

# GetCoreDevice
<a name="API_GetCoreDevice"></a>

Retrieves metadata for a Greengrass core device.

**Note**  
 AWS IoT Greengrass relies on individual devices to send status updates to the AWS Cloud. If the AWS IoT Greengrass Core software isn't running on the device, or if device isn't connected to the AWS Cloud, then the reported status of that device might not reflect its current status. The status timestamp indicates when the device status was last updated.  
Core devices send status updates at the following times:  
When the AWS IoT Greengrass Core software starts
When the core device receives a deployment from the AWS Cloud 
When the status of any component on the core device becomes `BROKEN` 
At a [regular interval that you can configure](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-nucleus-component.html#greengrass-nucleus-component-configuration-fss), which defaults to 24 hours
For AWS IoT Greengrass Core v2.7.0, the core device sends status updates upon local deployment and cloud deployment
When the AWS IoT Greengrass Core software connects to the AWS Cloud, your device will be recognized as a core device.

## Request Syntax
<a name="API_GetCoreDevice_RequestSyntax"></a>

```
GET /greengrass/v2/coreDevices/coreDeviceThingName HTTP/1.1
```

## URI Request Parameters
<a name="API_GetCoreDevice_RequestParameters"></a>

The request uses the following URI parameters.

 ** [coreDeviceThingName](#API_GetCoreDevice_RequestSyntax) **   <a name="greengrassv2-GetCoreDevice-request-uri-coreDeviceThingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_GetCoreDevice_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetCoreDevice_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "architecture": "string",
   "coreDeviceThingName": "string",
   "coreVersion": "string",
   "lastStatusUpdateTimestamp": number,
   "platform": "string",
   "runtime": "string",
   "status": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_GetCoreDevice_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [architecture](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-architecture"></a>
The computer architecture of the core device.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [coreDeviceThingName](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-coreDeviceThingName"></a>
The name of the core device. This is also the name of the AWS IoT thing.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [coreVersion](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-coreVersion"></a>
The version of the AWS IoT Greengrass Core software that the core device runs. This version is equivalent to the version of the Greengrass nucleus component that runs on the core device. For more information, see the [Greengrass nucleus component](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-nucleus-component.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [lastStatusUpdateTimestamp](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-lastStatusUpdateTimestamp"></a>
The time at which the core device's status last updated, expressed in ISO 8601 format.  
Type: Timestamp

 ** [platform](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-platform"></a>
The operating system platform that the core device runs.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [runtime](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-runtime"></a>
The runtime for the core device. The runtime can be:  
+  `aws_nucleus_classic` 
+  `aws_nucleus_lite` 
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [status](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-status"></a>
The status of the core device. The core device status can be:  
+  `HEALTHY` – The AWS IoT Greengrass Core software and all components run on the core device without issue.
+  `UNHEALTHY` – The AWS IoT Greengrass Core software or a component is in a failed state on the core device.
Type: String  
Valid Values: `HEALTHY | UNHEALTHY` 

 ** [tags](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.aws.amazon.com/greengrass/v2/developerguide/tag-resources.html) in the * AWS IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.

## Errors
<a name="API_GetCoreDevice_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 AWS IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.aws.amazon.com/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetCoreDevice_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/greengrassv2-2020-11-30/GetCoreDevice) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/greengrassv2-2020-11-30/GetCoreDevice) 
[...]
